hdu-1973 Prime Path

Prime Path

Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 371    Accepted Submission(s): 236


Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
 

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
 

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
 

Sample Input
  
  
3 1033 8179 1373 8017 1033 1033
 

Sample Output
  
  
6 7 0
 
题意:给一个起始四位素数start,每次变化一位数,最少经过多少次变换得到另一个四位素数end,变换过程中的数均为四位的素数,
返回变换的次数(即花费),广度优先搜索
#include <iostream>
#include<cstring>
#include <cmath>
#include <queue>
using namespace std;
bool mark[10000];
int a[5]={1,10,100,1000,10000};
int prim(int n)
{
    int t=sqrt(n*1.0)+1;
    if(n==2)
    return 1;
    for(int i=2;i<t;i++)
    if(n%i==0)
    return 0;
    return 1;
}
int n,k;
int bfs()
{
     queue<int> q;
     int t,s,num,step=0,temp;
     q.push(n);
     mark[n]=true;
     if(n==k)
     return 0;
     while(!q.empty())
     {
                      s=q.size();
                      step++;
                      while(s--)
                      {
                                t=q.front();
                                q.pop();
                                for(int i=0;i<4;i++)
                                {
                                        temp=t/a[i]-10*(t/a[i+1]);
                                        //cout <<temp<<" ";
                                        for(int j=-temp;j<10-temp;j++)
                                        {
                                                num=t+a[i]*j;
                                                if(num==k)
                                                {
                                                          return step;
                                                }
                                                if(num>9999 || num<1000)
                                                continue;
                                                if(prim(num) && !mark[num])
                                                {
                                                            // cout<<num<<" ";
                                                            mark[num]=true;
                                                            q.push(num);
                                                }
                                        }

                                }

                      }
                      //cout <<endl;
     }
}

int main()
{
    int t;
    cin >>t;
    while(t--)
    {
    memset(mark,false,sizeof(mark));
    cin >>n>>k;
    cout <<bfs()<<endl;
    }
    return 0;
}




  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值